function int distance_xy (int tid1, int tid2)
{
    int x, y, d;
    x = GetActorX(tid1) - GetActorX(tid2) >> 16; // Convert fixed point to integer
    y = GetActorY(tid1) - GetActorY(tid2) >> 16;
    d = sqrt( x*x + y*y );
    return d;
}

function int GetTargetAngle (int tid1, int tid2)
{
    int x, y;
    x = GetActorX(tid2) - GetActorX(tid1);
    y = GetActorY(tid2) - GetActorY(tid1);
    return VectorAngle(x, y);
}

/////////////////////////////////////////////////////////////////////////////////////////////////

script 789 (int force)
{
    int center = defaultTID(-1);
    
    int limit = 0;
    if(force > 30) limit = 1;
    
    SetActivatorToTarget(0);
    int updn;
    
    int gravity = GetActorProperty(0, APROP_Gravity);
    SetActorProperty(0, APROP_Gravity, 0);
    
    bool anyneed, anyneed2;

    while ( (distance_tid(0,center) >= 0.36) &&
            (GetActorProperty(0, APROP_Health) > 0) &&
            (GetActorProperty(center, APROP_Health) > 0) )
    {
        anyneed  = distance_xy(0, center) >= 0.2;
        anyneed2 = abs(GetActorZ(0) - GetActorZ(center)) >= (32 >> 16);
        updn = GetActorZ(0) > GetActorZ(center);
        
        SetActorVelocity(0, 0,0,0, 0,0);
        
        if (anyneed)  ThrustThing(GetTargetAngle(0, center) >> 8, force*5, limit, 0);
        if (anyneed2) ThrustThingZ(0, force*5, updn, 0);
        Delay(1);
    }
    
    TakeInventory("undercontrol", 1);
    SetActorProperty(0, APROP_Gravity, gravity);
    SetActorState(center, "Explode", 1);
    Delay(1);

    if ( (GetActorProperty(center, APROP_Health) > 0) &&
         (GetActorProperty(0, APROP_Health) <= 0))
    {
        if(PlayerNumber() >= 0) SetActorProperty (0, APROP_RenderStyle, Style_None);
        else
        {
            int victim = defaultTID(-1);
            SetActivator(center);
            Thing_Remove(victim);
        }
    }
    
}

script 790 (int duration)
{
    Delay(duration);
    SetActorState(0, "Dth", 1);
}

