function void GiveLelwep(int which)
{
    if (which == -1)
    {
        int i;
        GiveInventory("Backpack", 1);

        for (i = 0; i < LELWEPCOUNT; i++)
        {
            GiveInventory(LelWeps[i][0], 1);
            GiveInventory(LelWeps[i][1], GetAmmoCapacity(LelWeps[i][1]));
            GiveInventory(LelWeps[i][2], GetAmmoCapacity(LelWeps[i][2]));
        }
        return;
    }

    if (which < 0 || which >= LELWEPCOUNT) { return; }
    GiveInventory(LelWeps[which][0], 1);
    GiveInventory(LelWeps[which][1], GetAmmoCapacity(LelWeps[which][1]));
    GiveInventory(LelWeps[which][2], GetAmmoCapacity(LelWeps[which][2]));
}

function void TakeLelwep(int which)
{
    if (which == -1)
    {
        int i;
        for (i = 0; i < LELWEPCOUNT; i++)
        {
            TakeInventory(LelWeps[i][0], 1);
            TakeInventory(LelWeps[i][1], GetAmmoCapacity(LelWeps[i][1]));
            TakeInventory(LelWeps[i][2], GetAmmoCapacity(LelWeps[i][2]));
        }
        return;
    }

    if (which < 0 || which >= LELWEPCOUNT) { return; }
    TakeInventory(LelWeps[which][0], 1);
    TakeInventory(LelWeps[which][1], 0x7FFFFFFF);
    TakeInventory(LelWeps[which][2], 0x7FFFFFFF);
}

function int getFlagCVarName(int index)
{
    if (index / 32 == 0) { return STARTFLAGPREFIX; }
    return StrParam(s:STARTFLAGPREFIX, d:(index/32)+1);
}

function int lelwepCVar(int index)
{
    return cvarFromString(STARTCVARPREFIX, LelWeps[index][0]);
}

function int curFlagsIndex(int index)
{
    int flagIndex = index/32;
    int flagBit  = 1 << (index % 32);
    return !!(curFlags[flagIndex] & flagBit);
}

function int prevFlagsIndex(int index)
{
    int flagIndex = index/32;
    int flagBit  = 1 << (index % 32);
    return !!(prevFlags[flagIndex] & flagBit);
}

function int cvarFlagsIndex(int index)
{
    int flagIndex = index/32;
    int flagBit  = 1 << (index % 32);
    return !!(cvarFlags[flagIndex] & flagBit);
}

function int pushFlagsIndex(int index)
{
    int flagIndex = index/32;
    int flagBit  = 1 << (index % 32);
    return !!(pushFlags[flagIndex] & flagBit);
}


function void setFlag(int index, int mode)
{
    int flagIndex = index/32;
    int flagBit  = 1 << (index % 32);

    if (mode) { curFlags[flagIndex] |= flagBit; }
    else { curFlags[flagIndex] &= ~flagBit; }
}

function void setCVarFlag(int index, int mode)
{
    int flagIndex = index/32;
    int flagBit  = 1 << (index % 32);

    if (mode) { cvarFlags[flagIndex] |= flagBit; }
    else { cvarFlags[flagIndex] &= ~flagBit; }
}

function void pushFlag(int index, int mode)
{
    int flagIndex = index/32;
    int flagBit  = 1 << (index % 32);

    if (mode) { pushFlags[flagIndex] |= flagBit; }
    else { pushFlags[flagIndex] &= ~flagBit; }
}


function void firstSetFlags(void)
{
    int i, cvar, start;

    for (i = 0; i < FLAGFIELDCOUNT; i++)
    {
        cvar = getFlagCVarName(i*32);
        start = GetCVar(cvar);

        if (start == 0)
        {
            ConsoleCommand(StrParam(s:"set ", s:cvar, s:" 0"));
            ConsoleCommand(StrParam(s:"archivecvar ", s:cvar));
        }

        pushFlags[i] = 0;
        prevFlags[i] = start;
        curFlags[i] = start;
    }
}

function void shiftFlags(void)
{
    int i, cvar, start;

    for (i = 0; i < FLAGFIELDCOUNT; i++)
    {
        cvar = getFlagCVarName(i*32);
        start = GetCVar(cvar);

        pushFlags[i] = 0;
        prevFlags[i] = curFlags[i];
        curFlags[i] = start;
    }
}

function void getCVarFlags(void)
{
    int i, cvar, start;

    for (i = 0; i < LELWEPCOUNT; i++)
    {
        cvar = lelwepCVar(i);
        start = GetCVar(cvar);

        setCVarFlag(i, start);
    }
}

function void makeStartCVars(void)
{
    int i, cvar, start;

    for (i = 0; i < LELWEPCOUNT; i++)
    {
        cvar = lelwepCVar(i);
        start = curFlagsIndex(i);

        ConsoleCommand(StrParam(s:"set ", s:cvar, s:" ", d:start));
    }
}

function void updateFlags(void)
{
    int i, cvar, start;
    // Flag fields
    for (i = 0; i < FLAGFIELDCOUNT; i++)
    {
        cvar = getFlagCVarName(i*32);
        ConsoleCommand(StrParam(s:"set ", s:cvar, s:" ", d:pushFlags[i])); 
    }

    // CVars
    for (i = 0; i < LELWEPCOUNT; i++)
    {
        cvar = lelwepCVar(i);
        start = pushFlagsIndex(i);

        ConsoleCommand(StrParam(s:"set ", s:cvar, s:" ", d:start));
    }
}



function int startWithLelwep(int index)
{
    if (index < 0 || index >= LELWEPCOUNT) { return 0; }

    int fOn_cur = curFlagsIndex(index);
    int fOn_old = prevFlagsIndex(index);
    int cOn     = cvarFlagsIndex(index);

    //Log(d:fOn_cur, s:", ", d:fOn_old, s:", ", d:cOn);

    if (fOn_cur == cOn) { return fOn_cur; }  // no disagreement, we good
    if (fOn_cur != fOn_old) { return fOn_cur; }  // flag changed, respect that first
    return cOn;
}
