#define CHECK_TID       1
#define CHECK_NAME      2
#define CHECK_TEAM      3
#define CHECK_HP        4
#define CHECK_MAXHP     5
#define CHECK_FRIEND    6

script 451 (int which, int a1, int a2)
{
    int pln = PlayerNumber(), myTID = defaultTID(-1), myTeam = GetPlayerInfo(pln, PLAYERINFO_TEAM);
    int targetTID, targetName, targetHealth, targetMax, targetTeam, targetAlliance;
    int hpColor, nameColor, statStr;
    int isMonster, isFriendly, isEnemy, hasTeam, sameTeam, freeForAll;

    switch (which)
    {
      case 12:
        targetHealth = ACS_ExecuteWithResult(736, CHECK_HP,0,0);
        targetTID    = ACS_ExecuteWithResult(736, CHECK_TID,0,0);
        targetName   = ACS_ExecuteWithResult(736, CHECK_NAME,0,0);
        targetTeam   = ACS_ExecuteWithResult(736, CHECK_TEAM,0,0);
        targetMax    = ACS_ExecuteWithResult(736, CHECK_MAXHP,0,0);
        
        if (targetHealth > targetMax) { hpColor = "\cn"; }
        else { hpColor = "\ca"; }
        
        isMonster  = (targetTeam == -1);
        isFriendly = ACS_ExecuteWithResult(736, CHECK_FRIEND,0,0);
        sameTeam   = (myTeam == targetTeam);
        hasTeam    = !((targetTeam == 255) | (targetTeam == -1));
        freeForAll = isFreeForAll();
        
        if (isMonster)
        {
            if (hasTeam) { isEnemy = !sameTeam; }
            else { isEnemy = !isFriendly; }
        }
        else { isEnemy = freeForAll || !sameTeam; }
        
        if (myTID == targetTID) { isEnemy = -1; }
        
        if (isEnemy == -1) { targetAlliance = "\cfYOU\c-"; }
        else if (isEnemy) { targetAlliance = "\cgENEMY"; }
        else { targetAlliance = "\cdALLY"; }
        
        if ((targetTeam == 255) || (targetTeam == -1) || !isTeamGame())
        {
            nameColor = "\ck";
        }
        else
        {
            nameColor = teamColorCodes[targetTeam];
        }
        
        if (targetMax > 0)
        {
            statStr = StrParam(s:nameColor, s:"\"", s:targetName, s:nameColor,
            s:"\"\c-: (", s:targetAlliance, s:"\c-) ", s:hpColor, d:max(targetHealth, 0),
            s:"\cd/\cb", d:targetMax, s:"\c- (tid: ", d:targetTID, s:")");
        }
        else if (targetMax < 0)
        {
            statStr = StrParam(s:nameColor, s:"\"", s:targetName, s:nameColor,
            s:"\"\c-: (", s:targetAlliance, s:"\c-) \cgUNDEAD\c- (tid: ",
            d:targetTID, s:")");
        }
        else
        {
            statStr = StrParam(s:nameColor, s:"\"", s:targetName, s:nameColor,
            s:"\"\c-: (", s:targetAlliance, s:"\c (tid: ", d:targetTID, s:")");
        }
        
        HudMessage(s:statStr; HUDMSG_FADEOUT, 10595, CR_WHITE, 1.5, 0.2, 2.0, 0.5);
        break;
      
      case 16:
        SetActivatorToTarget(0);
        
        if (ActivatorTID() == myTID) { break; } // NO HEEL SELF
        
        giveHealthFactor(a1, itof(a2)/100);
        targetHealth = GetActorProperty(0, APROP_Health);
        
        if (targetHealth > getMaxHealth())
        {
            SetActorProperty(0, APROP_Friendly, 1);
        }
        break;
        
      case 17:
        giveHealthFactor(a1, itof(a2)/100);
        break;
    }
}

script 736 (int which)
{
    int ret = 0;
    SetActivatorToTarget(0);
    int hisPln = PlayerNumber();
    
    switch (which)
    {
      case CHECK_TID:
        ret = ActivatorTID();
        break;
        
      case CHECK_NAME:
        ret = StrParam(n:0);
        break;
        
      case CHECK_TEAM:
        ret = GetPlayerInfo(hisPln, PLAYERINFO_TEAM);
        break;
        
      case CHECK_HP:
        ret = GetActorProperty(0, APROP_Health);
        break;
        
      case CHECK_MAXHP:
        ret = getMaxHealth();
        
        if ((hisPln != -1) && (ret == 0))
        {
            ret = 100;
        }
        break;
        
      case CHECK_FRIEND:
        ret = GetActorProperty(0, APROP_Friendly);
        break;
    }
    
    SetResultValue(ret);
}
